#include <stdio.h> 
#include <stdlib.h>  
#include <string.h>  
#include <ctype.h> 
#include <conio.h> 
#include <math.h>
#define dim1 150 // hight of image
#define dim2 154 // width of image

char *trim(char *str) // removing spaces, new lines in the matrix-image when reading the file
// http://www8.cs.umu.se/~isak/snippets/trim.c
{
	  char *ibuf = str, *obuf = str;
	  int i = 0, cnt = 0;

	  // Trap NULL
	  if (str)
	  {		//  Remove leading spaces
			for (ibuf = str; *ibuf && isspace(*ibuf); ++ibuf);
			if (str != ibuf)  memmove(str, ibuf, ibuf - str);

			// Collapse embedded spaces
			while (*ibuf)
			{
				  if (isspace(*ibuf) && cnt)	ibuf++;
				  else
				  {   if (!isspace(*ibuf))  cnt = 0;
						else
						{      *ibuf = ' ';  
         cnt = 1; 
}
						obuf[i++] = *ibuf++;
				  }
			}
			obuf[i] = 0;

			// Remove trailing space
			while (--i >= 0)
			{	 if (!isspace(obuf[i]))	break;
			} 	
  obuf[++i] = 0;
	  }    return str;
}


//histogram calculation
void calcHist(int matr[dim1][dim2],long H[256]){ 
	int i,j;
	for(i=0;i<256;i++) H[i]=0; //histogram is represented with 256 gray levels 
		for(i=0; i<dim1; i++)
			for(j=0; j<dim2; j++) 
			{
				H[matr[i][j]]++; 	//calculating the frequency of each gray level
			}
}

//average filter using a sliding window of 3x3 on image
void average(int matr[dim1][dim2], int narr[dim1][dim2]){ 
	int i,j, k,l, sum;
	char ch;

	sum=0;
	for(i=0; i<dim1; i++)
		for(j=0; j<dim2; j++) {
			if(i==0 || j==0 || i==dim1-1 || j==dim2-1) narr[i][j]=matr[i][j]; //the first line and columns rest the same in the filtered image
			else{
				//using a sliding window of 3x3
				for(k=i-1;k<=i+1;k++) for(l=j-1;l<=j+1;l++) sum+=matr[k][l]; // Sum calculation of the elements for each window
				narr[i][j]=floor(sum/9); //the centered pixel have the average value of the window in the filtered image
				sum=0;
			}
		}
}

 //average filter for histogram using a window of 11 samples centered on position 6 
void filter_f11(long H[256]){
	long HTemp[256];//the auxiliar histogram
	long sum;
	int i,j;
		//
		for(i=5;i<256-5;i++)  {
			sum=0;
			// window of 11 samples centered on position 6
			for(j=i-5;j<i+5;j++) sum+=H[j]; 
			HTemp[i]=int(sum/11); //the filtered histogram
		} 
	 	for(i=5;i<256-5;i++) H[i]=HTemp[i]; 
}

//median filtre   http://www.librow.com/articles/article-1
void filter_median(long H[256]){   
	long HTemp[256];
	int i,j;
	int temp,*result;
	for (i = 2; i < 256 - 2; ++i) {
		//   Pick up window elements
		// window of 5 samples;
		for (j = 0; j < 5; ++j) HTemp[j] = H[i - 2 + j];
		//   Order elements (only half of them)
		for (int j = 0; j < 3; ++j)  {
			//   Find position of minimum element
			int min = j;
			for (int k = j + 1; k < 5; ++k)
				if (HTemp[k] < HTemp[min])  min = k;
			//   Put found minimum element in its place
			temp=HTemp[j];
			HTemp[j] = HTemp[min];
			HTemp[min] = temp;
		}
	   	//   Get result - the middle element
			H[i] = HTemp[2];
   } 
}

void HistInFile(long H[256],char *file ){ //writing the histogram in file
	FILE *fl;
	char nbr[5];
	fl=fopen(file,"w");
	if((fl=fopen(file,"w"))==NULL) 	puts("File can't be opened");

	for(int i=0;i<256;i++) {
		ltoa(H[i],nbr,10);
		fputs(strcat(nbr,"\n"),fl);
	} 
	fclose(fl); 
}
void showHist(long H[256]){
	char ch;
	for(int i=0;i<256;i++) {
		printf("%3d:  %li\n",i, H[i]);
		if((i+1)%25==0) {
			ch=getch();
			if(ch=='c') break;
		}
	}
}

void showMatrix(int matr[dim1][dim2], char* str) {
	printf("\n %s \n", str);
	for(int i=0;i<dim1;i++){
		for(int j=0;j<dim2;j++)	printf("%d  \t",matr[i][j]); 		
		printf("\n");
	}
}

void thresholdHNT(long H[256],int &pragm1, int &pragm2){
int i, k1, k2, min, max1, max2, prag1, prag2, prag01, prag02, pprag=0, ppragm=0, cont=0, fl=0, sct=24 ;
	double p1=0.2, p2=1.5;
	long HMax1,HMax2, VMin, VMax, VMinL, VMaxL;
	float res;
	char ch;
	HMax1=H[0];HMax2=H[0]; max1=0; max2=-1; k1=0;
	for(i=1; i<256; i++) if(HMax1<H[i]) { HMax1=H[i]; max1=i;}
	for(i=1; i<256; i++)
		if(HMax2<H[i] && H[i]!=HMax1 && H[i]>=ceil(p1*HMax1)) { HMax2=H[i]; max2=i;}
	printf("\n\n Max1=%li with gray level %d;\n\n Max2=%li with gray level %d;\n\n " , H[max1],max1,H[max2],max2);
	VMax=H[0]; VMin=H[0];
	i=0; min=0; prag01=0; prag02=0;
	do{
		if(i==(sct*(k1+1)-6*k1) || i==255){
			res=(float)(VMax-VMin)/cont;
			prag1=i-cont; prag2=i-1; //determining the limits of current interval
			if(res<p2){
				printf("\n Interval %d; prag1=%d, prag2=%d,  VMax= %li, VMin=%li, res=%f \n",k1,prag1,prag2,VMax,VMin,res);
				if(!fl) prag01=prag1; //initializing the left limit of the quasi-constant interval 
				prag02=prag2;	//initializing the right limit of the quasi-constant interval 
				pprag++;	//counting the number of the sub-intervals in the quasi-constant interval
				fl=1;
			}else fl=0;
						//if((!fl && (prag02==prag1+5)) || (fl && i==255)){ //represent the all quasi-constant interval
						if((!fl && (prag02==prag1+5))&& k1>0 ){  //not taken into consideration first and last quasi-constant intervals
				if(pprag>=ppragm) {pragm1=prag01; pragm2=prag02; ppragm=pprag;}
			printf("\n Continuous quasi-constant interval %d with the limits (thresholds):  %d si %d \n",pprag, prag01,prag02);
			}
			if(!fl) {
				pprag=0;
			printf("\n Interval %d;  VMax= %li; VMin=%li , res=%f \n",k1,VMax,VMin,res);
			}
			if(i==255) break;
			i-=6; cont=0;

			k1++;
			VMax=H[i]; VMin=H[i];
			ch=getch();
		}else{
			if(VMin>H[i]) VMin=H[i];	            //determining the minimum on the interval
			if(VMax<H[i]) VMax=H[i];	//determining the maximum on the interval
			i++;
			cont++;
		       }
		}while(i<256);
	if(ppragm>0) printf("\n Quasi-constant interval with maxim %d sub-intervals with the limits:  %d si %d \n",ppragm, pragm1,pragm2);
	else printf("\n Not detected any quasi-constant interval \n"); 
}

void calcMedia(long H[256]){
    int i, k1,  prag1, prag2, cont=0,  sct=24;
	long Sum;
	float res,s;
	char ch;
	 
	
	i=0; k1=0; Sum=0; 
	do{
		if(i==(sct*(k1+1)-6*k1) || i==255){
			res=(int)Sum/cont; s=sqrt((Sum-cont*res)/cont);
			prag1=i-cont; prag2=i-1; //determining the limits of current interval
			printf("\n Sector %d: %d - %d, media=%.2f, dispersia=%.2f \n",k1,prag1,prag2,res,s);
				
			if(i==255) break;
			i-=6; cont=0; Sum=0;

			k1++;
			
			ch=getch();
		}else{
			Sum+=H[i];	//computing the elements by interval
			i++;
			cont++;
		}
	}while(i<256);	
}

void calc_Mediana(long H[256]){             
	long HTemp[256];
	int i, j, k1, mdl,  prag1, prag2, cont=0,  sct=24; //auxiliary variable
	int ch, temp;
	
	for(i=0;i<256; i++) HTemp[i]=H[i];
	i=0; k1=0;
	do{
		if(i==(sct*(k1+1)-6*k1) || i==256){

			prag1=i-cont; 
			prag2=i-1; //determining the limits of current interval
			mdl=int(cont/2)+1;
				//   Order elements (only half of them)
			for (int j = 0; j < mdl; ++j)  {
				//   Find position of minimum element
				int min = prag1+j;
				for (int k = min + 1; k <= prag2; k++)
					if (HTemp[k] < HTemp[min])  min = k;
				//   Put found minimum element in its place
				//const element temp = window[j];

				if(min > prag1+j){
					temp=HTemp[prag1+j];
					HTemp[prag1+j] = HTemp[min];
					HTemp[min] = temp;
				}

			}
			//   Get result - the middle element
			
			printf("\n Interval %d: %d - %d, the median=%d ",k1,prag1+1,prag2+1,HTemp[prag1+mdl-1]); 
			for(j=prag2-6;j<=prag2;j++) HTemp[j]=H[j];
			if(i==256) break;
			i-=6; cont=0;

			k1++;

			ch=getch();
		}else{
			printf("%d \t",HTemp[i]);
			i++;
			cont++;
			
		}
	}while(i<=256);	
}

void removeNoise(int matr[dim1][dim2],int new_arr[dim1][dim2])
 { //elimination of noise points
	int i,j,k,l,cont;

	for(i=0; i<dim1; i++)		
		for(j=0; j<dim2; j++) {	
			cont=0;
			if(i==0 || j==0 || i==dim1-1 || j== dim2-1) new_arr[i][j]=matr[i][j];
			else {				
				for(k=i-1;k<=i+1;k++)
				   for(l=j-1;l<=j+1;l++)
				   		if(matr[k][l]==256) cont++;

				if(cont>=7){
					for(k=i-1;k<i+1;k++)
						for(l=j-1;l<j+1;l++) 
							new_arr[k][l]=256;									
				}else new_arr[i][j]=matr[i][j];
			}
			//printf("(%d,%d:%d)%d\t", i,j,cont,new_arr[i][j]);
		}
}

void similarity(int ms1[dim1][dim2],int ms2[dim1][dim2])
{	
	FILE *f1, *f2; //read file1 and file2
	char name[6], ch;
	
	int c, i, j;
 	long sum=0;
	 float k;

	f1=fopen("D:/C-Free Standard/samples/work/ms1.txt","r"); //reading the image-matrix of file
	c=0; i=0; j=0;
	while(fgets(name, 5, f1)!=NULL) if(strlen(trim(name))>0){
		ms1[i][j]=atoi(name); 
		//printf("%d  -  %d\t",c,ms1[i][j]); 
		c++;

		if(c%dim2==0) { //read line by line
			j=0; i++;
		}else j++; 
	}
	
	fclose(f1);

	f2=fopen("D:/C-Free Standard/samples/work/ms2.txt","r"); //reading the image-matrix of file
//	printf("Original matrix: \n");
	c=0; i=0; j=0;
	while(fgets(name, 5, f2)!=NULL) if(strlen(trim(name))>0){
		ms2[i][j]=atoi(name); 
	//	printf("%d  -  %d\t",c,ms2[i][j]); 
		c++;

		if(c%dim2==0) { //read line by line
			j=0; i++;
		}else j++; 
	}


	fclose(f2);

  for(i=0;i<dim1;i++){ 
	for(j=0;j<dim2;j++){
		sum+=abs(ms1[i][j]-ms2[i][j]);
		 //printf("\n sum=%li", sum);
	}

	
  }

  k=(float)sum/(dim1*dim2);
  printf("\n k=%f", k);
  	if(k<=5/100) printf("\n Images are similar\n");
	else printf("\n Images are not similar\n");

	getch();
}


void main(void){
	FILE *r;
	char name[6], ch;
	int matrice[dim1][dim2],M1[dim1][dim2],M2[dim1][dim2],M3[dim1][dim2],M4[dim1][dim2],M5[dim1][dim2],M6[dim1][dim2];
	long Hist[256];
	int c, i, j, pr, prag1, prag2,a;

	r=fopen("D:/C-Free Standard/samples/work/blood.txt","r"); //reading the image-matrix file
	printf("Original image matrix: \n");
	c=0; i=0; j=0;
	while(fgets(name, 5, r)!=NULL) if(strlen(trim(name))>0){
		matrice[i][j]=atoi(name);
   	 	//	printf("%d  - matrix %d %d= %d\n",c,i,j,matrice[i][j]); 
		c++;

		if(c%dim2==0) {j=0; i++;} //read line by line
		else j++;
	}

	fclose(r);
	
	calcHist(matrice,Hist);

	do{
		printf("================================================\n");
		printf("===================== MENU =====================\n");
		printf("== 1. Image filtering                         ==\n");
		printf("== 2. Histogram filtering                     ==\n");
		printf("== 3. The quasi-constant intervals            ==\n");
		printf("== 4. Image segmentation (with 2 thresholds)  ==\n");
		printf("== 5. View separate segments (three segments) ==\n");
		printf("== 6. Removing noise from the segments        ==\n");
		printf("== 7. Similary test                           ==\n");
		printf("== 8. Exit                                    ==\n");
		printf("================================================\n\n");

		printf(" Your choice: ");
 		scanf("%d", &a);
 		
		switch (a){
			case 1:	average(matrice,M1);
					printf("\n Do you want to see the rezult? (y/n) "); 
					ch=getch(); scanf("%c", &ch);
 					if(ch=='y') showMatrix(M1," Result after filtering with average filter ");	
					break;
			case 2: printf("\n Do you want to apply the median filter or average filter? (m/a) ");
					ch=getch(); scanf("%c", &ch);
 					if(ch=='m') {
					 	filter_median(Hist);
					 	printf("\n Median filter applied!\n");
 					}else if(ch=='a') {
					 		filter_f11(Hist);
					 		printf("\n Average filter applied!\n");
 						}
 						else printf("\n Incorrect choice!\n");
 					break;
			case 3:	thresholdHNT(Hist, prag1, prag2);
					printf("\n The maxim quasi-constant interval with the limits (thresholds):  %d si %d \n", prag1, prag2);
					break;
			case 4://The segmented image
					//printf("\n The segmented image\n"); 	
					for(i=0; i<dim1; i++){
						for(j=0; j<dim2; j++){
							if(matrice[i][j]<prag1) matrice[i][j]=50;
							if(matrice[i][j]>=prag1 && matrice[i][j]<=prag2) matrice[i][j]=100;
							if(matrice[i][j]>prag2) matrice[i][j]=200; 
						}
					}  printf("\n The image was segmented \n"); 
					
					FILE *f; //f is a pointer to a file
					//opens the file in write mode
					if((f=fopen("D:/C-Free Standard/samples/work/blood2.txt","w"))==NULL)
					puts("File can't be opened");
					for (i=0;i<dim1;i++){ //elements are written sequentially
	 					for(j=0;j<dim2;j++){
								fprintf (f, "%d\t", matrice[i][j]);
						}fprintf(f, "\n");
	 				}
	 				fclose (f); //the file is closed
					break; 
					
			case 5: do {
					printf("You want to view one of the three segments?\n\n");
					printf("Segment 1 - matrix values lower than a first threshold\n");
					printf("Segment 2 - matrix values included between the two thresholds\n");
					printf("Segment 3 - matrix values higher than second threshold\n");
					printf("\n 0 Exit \n");
	
					printf("\n Your choice for segment: ");
				 	scanf("%d", &a);
				 	
				 	if(a==1){
					 	 for(i=0;i<dim1;i++){
							for(j=0;j<dim2;j++){
								if(matrice[i][j]<prag1) M1[i][j]=50;
									else M1[i][j]=256; printf("%d \t", M1[i][j]);}}
									FILE *m1; //m1 is a pointer to a file
									//opens the file in write mode
									if((m1=fopen("D:/C-Free Standard/samples/work/m1.txt","w"))==NULL)
									puts("File can't be opened");
									for (i=0;i<dim1;i++) //elements are written sequentially
	 								{
										for(j=0;j<dim2;j++)	fprintf (m1, "%d \t", M1[i][j]);
										fprintf(m1, "\n");
	 								}
									fclose (m1); 
					}else if(a==2){						
						for(i=0;i<dim1;i++){
							for(j=0;j<dim2;j++){
								if(matrice[i][j]>=prag1 && matrice[i][j]<=prag2) M2[i][j]=100;
			 						else M2[i][j]=256; printf("%d \t", M2[i][j]);}}
			 						FILE *m2; //m1 is a pointer to a file
									//opens the file in write mode
									if((m2=fopen("D:/C-Free Standard/samples/work/m2.txt","w"))==NULL)
									puts("File can't be opened");
									for (i=0;i<dim1;i++) //elements are written sequentially
	 								{
										for(j=0;j<dim2;j++)	fprintf (m2, "%d \t", M2[i][j]);
										fprintf(m2, "\n");
	 								}
									fclose (m2);
					}else if(a==3){							
						for(i=0;i<dim1;i++){
							for(j=0;j<dim2;j++){
								if(matrice[i][j]>prag2) M3[i][j]=200;
									else M3[i][j]=256; printf("%d \t", M3[i][j]);}}
									FILE *m3; //m1 is a pointer to a file
									//opens the file in write mode
									if((m3=fopen("D:/C-Free Standard/samples/work/m3.txt","w"))==NULL)
									puts("File can't be opened");
									for (i=0;i<dim1;i++) //elements are written sequentially
	 								{
										for(j=0;j<dim2;j++)	fprintf (m3, "%d \t", M3[i][j]);
										fprintf(m3, "\n");
	 								}
									fclose (m3);
					}else  printf("\n Incorrect choice!\n");
			}while (a != 0);
					break;	
			case 6:	removeNoise(matrice,M4);	
					FILE *fp; //fp este un pointer catre un fisier
					//se deschide fisierul in mod scriere (write)
					if((fp=fopen("D:/C-Free Standard/samples/work/blood_m12.txt","w"))==NULL) puts("Fisierul nu poate fi deschis");
					for (i=0;i<dim1;i++) //se scriu succesiv elementele
					 {
						for(j=0;j<dim2;j++)
						{
							fprintf (fp, "%d \t", M4[i][j]);
						}fprintf(fp, "\n");
					 }	
					printf("\n The noise is removed. The result is copied in the file blood_m12.txt ");
					break;
		    case 7: similarity(M5,M6);
		    		printf("\n The similarity comparisation is compete ");
		    		break;
    		case 8: break;
   		    default:
               printf("\n choose options from 1-8\n\n");
           	}
	
	}while (a !=8);
	return 0;

}

	
